﻿Imports System.IO

Public Class Form1
    Private WithEvents usbMonitor As New USBListener()
    Public allDrives() As DriveInfo = DriveInfo.GetDrives()

    Public Sub New()
        AddHandler Application.ThreadException, AddressOf ExceptionHandlerForErrors
        AddHandler AppDomain.CurrentDomain.UnhandledException, AddressOf ExceptionHandlerForErrors
        usbMonitor.StartMonitoring()
        InitializeComponent()
        ListDrives()
    End Sub

#Region "USB-Listener"
    Private _eventinfos As String

    Private Sub usbMonitor_USBEvent(sender As Object, e As USBEventArgs) Handles usbMonitor.USBEvent
        If e.IsInserted Then
            ' USB-Stick wurde eingesteckt
            Debug.WriteLine("Ein USB-Gerät wurde eingesteckt!")
            ' Weitere Aktionen, die nach dem Event ausgeführt werden sollen
            ListDrives()
            _eventinfos = "Ein USB-Gerät wurde eingesteckt!"
            DisplayEventinfos(_eventinfos)
        Else
            ' USB-Stick wurde abgezogen
            Debug.WriteLine("Ein USB-Gerät wurde abgezogen!")
            ' Weitere Aktionen, die nach dem Event ausgeführt werden sollen
            ListDrives()
            _eventinfos = "Ein USB-Gerät wurde abgezogen!"
            DisplayEventinfos(_eventinfos)
        End If
    End Sub

    Private Sub usbMonitor_TimerElapsed(sender As Object, e As EventArgs) Handles usbMonitor.TimerElapsed
        Debug.WriteLine("3 Sekunden vergangen.")
        lblEventinfos.Text = Nothing
    End Sub

    Private Sub DisplayEventinfos(message As String)
        lblEventinfos.Text = message
    End Sub
#End Region

    Private Sub ExceptionHandlerForErrors(sender As Object, e As System.Threading.ThreadExceptionEventArgs)
        ShowError(e.Exception)
    End Sub

    Private Sub ExceptionHandlerForErrors(sender As Object, e As System.UnhandledExceptionEventArgs)
        ShowError(DirectCast(e.ExceptionObject, Exception))
    End Sub

    Private Sub ShowError(ex As Exception)
        Dim EventMessage As String = "Ein Fehler ist aufgetreten!" & Environment.NewLine & ex.Message
        MessageBox.Show(EventMessage, "Wichtige Info", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    Private Sub ListDrives()

        cmbDrives.Items.Clear()

        For Each drive As DriveInfo In allDrives
            If drive.IsReady Then
                Dim label As String = drive.VolumeLabel
                If Not String.IsNullOrEmpty(label) AndAlso label.All(Function(c) Char.IsLetterOrDigit(c) OrElse Char.IsWhiteSpace(c)) Then
                    cmbDrives.Items.Add(drive.Name & " (" & label & ")")
                Else
                    cmbDrives.Items.Add(drive.Name)
                End If
            End If
        Next

        If cmbDrives.Items.Count > 0 Then
            cmbDrives.SelectedIndex = 0
        End If

    End Sub
End Class
